/****************************************************************************
 *                   ^     +----- |  / ^     ^ |     | +-\                  *
 *                  / \    |      | /  |\   /| |     | |  \                 *
 *                 /   \   +---   |<   | \ / | |     | |  |                 *
 *                /-----\  |      | \  |  v  | |     | |  /                 *
 *               /       \ |      |  \ |     | +-----+ +-/                  *
 ****************************************************************************
 * AFKMud Copyright 1997-2003 by Roger Libiez (Samson),                     *
 * Levi Beckerson (Whir), Michael Ward (Tarl), Erik Wolfe (Dwip),           *
 * Cameron Carroll (Cam), Cyberfox, Karangi, Rathian, Raine, and Adjani.    *
 * All Rights Reserved.                                                     *
 *                                                                          *
 * Original SMAUG 1.4a written by Thoric (Derek Snider) with Altrag,        *
 * Blodkai, Haus, Narn, Scryn, Swordbearer, Tricops, Gorog, Rennard,        *
 * Grishnakh, Fireblade, and Nivek.                                         *
 *                                                                          *
 * Original MERC 2.1 code by Hatchet, Furey, and Kahn.                      *
 *                                                                          *
 * Original DikuMUD code by: Hans Staerfeldt, Katja Nyboe, Tom Madsen,      *
 * Michael Seifert, and Sebastian Hammer.                                   *
 ****************************************************************************
 *                           Deity handling module                          *
 ****************************************************************************/

#define DEITY_DIR "../deity/"	 /* Deity data dir		*/
#define DEITY_LIST "deity.lst" /* List of deities		*/

#define IS_DEVOTED(ch) ( !IS_NPC((ch)) && (ch)->pcdata->deity )

typedef struct deity_data DEITY_DATA;

extern DEITY_DATA *first_deity;
extern DEITY_DATA *last_deity;

struct deity_data
{
   DEITY_DATA *next;
   DEITY_DATA *prev;
   char *filename;
   char *name;
   char *deitydesc;
   sh_int alignment;
   sh_int worshippers;
   sh_int scorpse;
   sh_int sdeityobj;
   sh_int sdeityobj2;
   sh_int savatar;
   sh_int smount; /* Added by Tarl 24 Feb 02 */
   sh_int sminion; /* Added by Tarl 24 Feb 02 */
   sh_int sspell1; /* Added by Tarl 24 Mar 02 */
   sh_int sspell2; /* Added by Tarl 24 Mar 02 */
   sh_int sspell3; /* Added by Tarl 24 Mar 02 */
   sh_int srecall;
   sh_int flee;
   sh_int flee_npcrace;
   sh_int flee_npcfoe;
   sh_int kill;
   sh_int kill_magic;
   sh_int kill_npcrace;
   sh_int kill_npcfoe;
   sh_int sac;
   sh_int bury_corpse;
   sh_int aid_spell;
   sh_int aid;
   sh_int backstab;
   sh_int steal;
   sh_int die;
   sh_int die_npcrace;
   sh_int die_npcfoe;
   sh_int spell_aid;
   sh_int dig_corpse;
   int race;
   int race2;
   int race3;
   int race4;
   int Class;
   int Class2;
   int Class3;
   int Class4;
   int element;
   int element2; /* Added by Tarl 24 Feb 02 */
   int element3; /* Added by Tarl 24 Feb 02 */
   int sex;
   EXT_BV affected;
   EXT_BV affected2; /* Added by Tarl 24 Feb 02 */
   EXT_BV affected3; /* Added by Tarl 24 Feb 02 */
   int npcrace;
   int npcfoe;
   int suscept;
   int suscept2; /* Added by Tarl 24 Feb 02 */
   int suscept3; /* Added by Tarl 24 Feb 02 */
   int susceptnum;
   int susceptnum2; /* Added by Tarl 24 Feb 02 */
   int susceptnum3; /* Added by Tarl 24 Feb 02 */
   int elementnum;
   int elementnum2; /* Added by Tarl 24 Feb 02 */
   int elementnum3; /* Added by Tarl 24 Feb 02 */
   int affectednum;
   int affectednum2; /* Added by Tarl 24 Feb 02 */
   int affectednum3; /* Added by Tarl 24 Feb 02 */
   sh_int spell1; /* Added by Tarl 24 Mar 02 */
   sh_int spell2; /* Added by Tarl 24 Mar 02 */
   sh_int spell3; /* Added by Tarl 24 Mar 02 */
   int objstat;
   int recallroom; /* Samson 4-13-98 */
   int avatar; /* Restored by Samson 8-1-98 */
   int mount; /* Added by Tarl 24 Feb 02 */
   int minion; /* Added by Tarl 24 Feb 02 */
   int deityobj; /* Restored by Samson 8-1-98 */
   int deityobj2;
};
