/****************************************************************************
 *                   ^     +----- |  / ^     ^ |     | +-\                  *
 *                  / \    |      | /  |\   /| |     | |  \                 *
 *                 /   \   +---   |<   | \ / | |     | |  |                 *
 *                /-----\  |      | \  |  v  | |     | |  /                 *
 *               /       \ |      |  \ |     | +-----+ +-/                  *
 ****************************************************************************
 * AFKMud Copyright 1997-2003 by Roger Libiez (Samson),                     *
 * Levi Beckerson (Whir), Michael Ward (Tarl), Erik Wolfe (Dwip),           *
 * Cameron Carroll (Cam), Cyberfox, Karangi, Rathian, Raine, and Adjani.    *
 * All Rights Reserved.                                                     *
 *                                                                          *
 * Original SMAUG 1.4a written by Thoric (Derek Snider) with Altrag,        *
 * Blodkai, Haus, Narn, Scryn, Swordbearer, Tricops, Gorog, Rennard,        *
 * Grishnakh, Fireblade, and Nivek.                                         *
 *                                                                          *
 * Original MERC 2.1 code by Hatchet, Furey, and Kahn.                      *
 *                                                                          *
 * Original DikuMUD code by: Hans Staerfeldt, Katja Nyboe, Tom Madsen,      *
 * Michael Seifert, and Sebastian Hammer.                                   *
 ****************************************************************************
 *                       Shop and repair shop module                        *
 ****************************************************************************/

#define SHOP_DIR "../shops/" 	/* Clan/PC shopkeepers - Samson 7-16-00 */

typedef struct shop_data SHOP_DATA;
typedef struct repairshop_data REPAIR_DATA;

extern SHOP_DATA *first_shop;
extern SHOP_DATA *last_shop;
extern REPAIR_DATA *first_repair;
extern REPAIR_DATA *last_repair;

/*
 * Shop types.
 */
#define MAX_TRADE	 5

struct shop_data
{
   SHOP_DATA *next;			/* Next shop in list		*/
   SHOP_DATA *prev;			/* Previous shop in list	*/
   int keeper;			/* Vnum of shop keeper mob	*/
   sh_int buy_type [MAX_TRADE];	/* Item types shop will buy	*/
   sh_int profit_buy;		/* Cost multiplier for buying	*/
   sh_int profit_sell;		/* Cost multiplier for selling	*/
   sh_int open_hour;		/* First opening hour		*/
   sh_int close_hour;		/* First closing hour		*/
};

#define MAX_FIX		3
#define SHOP_FIX	1
#define SHOP_RECHARGE	2

struct repairshop_data
{
   REPAIR_DATA *next;			/* Next shop in list		*/
   REPAIR_DATA *prev;			/* Previous shop in list	*/
   int keeper;		/* Vnum of shop keeper mob	*/
   sh_int fix_type [MAX_FIX];	/* Item types shop will fix	*/
   sh_int profit_fix;		/* Cost multiplier for fixing	*/
   sh_int shop_type;		/* Repair shop type		*/
   sh_int open_hour;		/* First opening hour		*/
   sh_int close_hour;		/* First closing hour		*/
};
